/*
 * LCD_C.C
 * 17 August 2000
 *
 * LCD interface example
 * JK microsystems, Inc.
 * http://www.jkmicro.com
 *
 * THIS PROGRAM IS DISTRIBUTED WITHOUT ANY WARRANTY;
 * WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY
 * OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include <stdio.h>
#include <time.h>
#include <conio.h>

#define LCD_CMD 160				/* command for LCD driver */
#define LCD_CMD1 40             /* i/o format setup command */
#define LCD_CMD2 6              /* cursor setup command */
#define CLR_HOME 1              /* clear and home command */

void main( void )
{
	time_t 		sec_now, sec_prev=0;	/* time in seconde, 2 copies */
	struct 	tm 	*tm_now;                /* time/date structure */
	FILE		*lcd;					/* stream for LCD data */
	unsigned char	lcd_pos=0xC5;		/* demo position w/ variable */

/* **** when using Borland 4.52, use the STDPRN device: */
#if __BORLANDC__ >= 0x400
	lcd=stdprn;
#else
/* **** when using Turbo C, open the printer port as a file */
	lcd=fopen("LPT1","w");				/* open LPT1 (lcd driver) for output */
#endif

	setbuf(lcd, NULL);						/* disable buffering */

	fprintf(lcd,"%c%c",LCD_CMD,LCD_CMD1);	/* with defined commands */
	fprintf(lcd,"%c%c",LCD_CMD,40);         /* with decimal commands */
	fprintf(lcd,"%c%c",LCD_CMD,0xC);        /* with hex commands */
	fprintf(lcd,"%c%c",LCD_CMD,LCD_CMD2);
	fprintf(lcd,"%c%c",LCD_CMD,CLR_HOME);

	while ( !kbhit() ) {              		/* loop until key hit */
		time(&sec_now);                 	/* get time in (sec since whenever) */
		if (sec_now != sec_prev) {      	/* see if new time */
			sec_prev=sec_now;
			tm_now=localtime(&sec_now);		/* convert seconds to string */

			fprintf(lcd,"%c%c",LCD_CMD,lcd_pos);	/* position cursor */
			fprintf(lcd,"%02d-%02d-%02d",        	/* print date, note: mon is 0-11 and */
				tm_now->tm_mon+1,tm_now->tm_mday,tm_now->tm_year+1900);	/* date is yrs since 1900 */
			fprintf(lcd,"%c%c",LCD_CMD,0x9A);   	/* position cursor */
			fprintf(lcd,"%02d:%02d:%02d",           /* print time */
				tm_now->tm_hour,tm_now->tm_min,	tm_now->tm_sec);
		}
	}
	getch();					/* gobble keypress */

#if __BORLANDC__ < 0x400		/* if we opened lcd as a file, close it */
	fclose(lcd);
#endif

	return;
}
